'\"
'\" Generated from file '/net/nas/data/andreask/Dev/Struct/struct/embedded/man/files/cslice/cslice.n' by tcllib/doctools with format 'nroff'
'\"
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" RCS: @(#) $Id: man.macros,v 1.1 2009/01/30 04:56:47 andreas_kupries Exp $
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH "c::slice" n 1 doc "Tcl Data Structures"
.BS
.SH NAME
c::slice \- Create and manipulate C-level array slices
.SH SYNOPSIS
package require \fBTcl  8.5\fR
.sp
package require \fBc::slice  ?1?\fR
.sp
\fBCSLICE\fR \fBcslice_create\fR ( \fBlong int\fR \fIcc\fR, \fBvoid**\fR \fIcv\fR )
.sp
void \fBcslice_destroy\fR ( \fBCSLICE\fR \fIs\fR )
.sp
void \fBcslice_get\fR ( \fBCSLICE\fR \fIs\fR, \fBlong int*\fR \fIcc\fR, \fBvoid***\fR \fIcv\fR )
.sp
void \fBcslice_revers\fR ( \fBCSLICE\fR \fIs\fR )
.sp
void \fBcslice_concat\fR ( \fBCSLICE\fR \fIa\fR \fBCSLICE\fR \fIb\fR )
.sp
\fBCSLICE\fR \fBcslice_from_list\fR ( \fBTcl_Interp*\fR \fIinterp\fR \fBTcl_Obj*\fR \fIl\fR )
.sp
\fBTcl_Obj*\fR \fBcslice_to_list\fR ( \fBCSLICE\fR \fIs\fR )
.sp
\fBlong int\fR \fBcslice_size\fR ( \fBCSLICE\fR \fIs\fR )
.sp
\fBvoid*\fR \fBcslice_at\fR ( \fBCSLICE\fR \fIs\fR \fBlong int\fR \fIat\fR )
.sp
.BE
.SH DESCRIPTION
.PP
Welcome to Struct, a set of packages providing various data structures
to Tcl, and additional operations for existing Tcl structures.
.PP
This package provides a basic C API for the creation and use of
continous array slices. It does provide neither Tcl commands nor other
items visible at script level.
.PP
The package is meant to be used by other C level data structure
packages, as a means to provide access to parts of their internal
data, assuming that they are (conceptually) an array.
.PP
To support this the package provides its C API by means of a
stubs table which can be imported.
.SH API
.TP
\fBCSLICE\fR \fBcslice_create\fR ( \fBlong int\fR \fIcc\fR, \fBvoid**\fR \fIcv\fR )
This function creates and initializes a slice object with the
specified slice of an array of cells. The return value of the function
is the handle of the new slice object.
.TP
void \fBcslice_destroy\fR ( \fBCSLICE\fR \fIs\fR )
This function destroys the specified slice object, releasing all
allocated memory.
.TP
void \fBcslice_get\fR ( \fBCSLICE\fR \fIs\fR, \fBlong int*\fR \fIcc\fR, \fBvoid***\fR \fIcv\fR )
This function provides access to the slice of cells contained in the
specified slice object.
.TP
void \fBcslice_revers\fR ( \fBCSLICE\fR \fIs\fR )
This function creates a new slice which is the reverse of the input.
The input slice is destroyed.
.TP
void \fBcslice_concat\fR ( \fBCSLICE\fR \fIa\fR \fBCSLICE\fR \fIb\fR )
This function creates a new slice which is the concatenation of the
two inputs. The input slices are destroyed.
.TP
\fBCSLICE\fR \fBcslice_from_list\fR ( \fBTcl_Interp*\fR \fIinterp\fR \fBTcl_Obj*\fR \fIl\fR )
This function creates a new slice containing the elements of the Tcl
list object \fIl\fR.
.sp
If \fIl\fR was not a list object \fB0\fR is returned, and an
error message left in the interpreter \fIinterp\fR. Note that
\fIinterp\fR can be \fB0\fR, in that case no error message is left.
.TP
\fBTcl_Obj*\fR \fBcslice_to_list\fR ( \fBCSLICE\fR \fIs\fR )
This function creates a new Tcl list object containing the elements
of the slice. This makes sense if and only if the elements of the slice
are of type \fBTcl_Obj*\fR. Any other type and the resulting Tcl object
is broken, causing a crash at some point in the future.
.TP
\fBlong int\fR \fBcslice_size\fR ( \fBCSLICE\fR \fIs\fR )
This function returns the size of the slice \fIs\fR.
.TP
\fBvoid*\fR \fBcslice_at\fR ( \fBCSLICE\fR \fIs\fR \fBlong int\fR \fIat\fR )
This function returns the element at index \fIat\fR in slice \fIs\fR.
.PP
.SH LICENSE
This package, written by Andreas Kupries, is BSD licensed.
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems.
Please report such at the
\fIStruct Tracker\fR [https://chiselapp.com/user/andreas_kupries/repository/Struct/index].
Please also report any ideas for enhancements you may have for either
package and/or documentation.
.SH KEYWORDS
array slice, data structures, slice
.SH CATEGORY
Data structures